# Leviton Cloud Services API model AreaSnapshot.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class AreaSnapshot(BaseModel):
    def __init__(self, session):
        super(AreaSnapshot, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_area(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/{0}/area".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_installation(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/{0}/installation".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/findOne"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def post_update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/update"
        session.call_api(api, attribs, 'post')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    @staticmethod
    def post_change_stream(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/AreaSnapshots/change-stream"
        session.call_api(api, attribs, 'post')

    def get_area_snapshot(self, area_snapshots, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/areaSnapshots/{1}".format(self._id, area_snapshots)
        self._session.call_api(api, attribs, 'get')

    def delete_area_snapshot(self, area_snapshots, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/areaSnapshots/{1}".format(self._id, area_snapshots)
        self._session.call_api(api, attribs, 'delete')

    def put_area_snapshot(self, area_snapshots, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/areaSnapshots/{1}".format(self._id, area_snapshots)
        self._session.call_api(api, attribs, 'put')

    def get_area_snapshots(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/areaSnapshots".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_area_snapshots(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/areaSnapshots".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_area_snapshots(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/areaSnapshots".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/areaSnapshots/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

