# Leviton Cloud Services API model FeedItem.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class FeedItem(BaseModel):
    def __init__(self, session):
        super(FeedItem, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_controller(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/controller".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_installation(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/installation".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_load(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/load".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_organization(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/organization".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_person(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/person".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_sensor(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/sensor".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_shade(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/shade".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_thermostat(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/thermostat".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/findOne"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/FeedItems/count"
        session.call_api(api, attribs, 'get')

    def get_feed_item(self, feed_items, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Locations/{0}/feedItems/{1}".format(self._id, feed_items)
        self._session.call_api(api, attribs, 'get')

    def get_feed_items(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Locations/{0}/feedItems".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Locations/{0}/feedItems/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def delete_feed_item(self, feed_items, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ManagementTiers/{0}/feedItems/{1}".format(self._id, feed_items)
        self._session.call_api(api, attribs, 'delete')

    def put_feed_item(self, feed_items, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ManagementTiers/{0}/feedItems/{1}".format(self._id, feed_items)
        self._session.call_api(api, attribs, 'put')

    def post_feed_items(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ManagementTiers/{0}/feedItems".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_feed_items(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ManagementTiers/{0}/feedItems".format(self._id)
        self._session.call_api(api, attribs, 'delete')

