# Leviton Cloud Services API model OmniNotifier.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class OmniNotifier(BaseModel):
    def __init__(self, session):
        super(OmniNotifier, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_residence(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/residence".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_omni_notifier_email(self, omni_notifier_emails, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/omniNotifierEmails/{1}".format(self._id, omni_notifier_emails)
        self._session.call_api(api, attribs, 'get')

    def delete_omni_notifier_email(self, omni_notifier_emails, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/omniNotifierEmails/{1}".format(self._id, omni_notifier_emails)
        self._session.call_api(api, attribs, 'delete')

    def put_omni_notifier_email(self, omni_notifier_emails, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/omniNotifierEmails/{1}".format(self._id, omni_notifier_emails)
        self._session.call_api(api, attribs, 'put')

    def get_omni_notifier_emails(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/omniNotifierEmails".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_omni_notifier_emails(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/omniNotifierEmails".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_omni_notifier_emails(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/omniNotifierEmails".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/omniNotifierEmails/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/findOne"
        session.call_api(api, attribs, 'get')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    @staticmethod
    def get_get_session_id(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/getSessionId"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def post_send_email(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifiers/sendEmail"
        session.call_api(api, attribs, 'post')

    def get_omni_notifier(self, omni_notifiers, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/omniNotifiers/{1}".format(self._id, omni_notifiers)
        self._session.call_api(api, attribs, 'get')

    def delete_omni_notifier(self, omni_notifiers, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/omniNotifiers/{1}".format(self._id, omni_notifiers)
        self._session.call_api(api, attribs, 'delete')

    def put_omni_notifier(self, omni_notifiers, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/omniNotifiers/{1}".format(self._id, omni_notifiers)
        self._session.call_api(api, attribs, 'put')

    def get_omni_notifiers(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/omniNotifiers".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_omni_notifiers(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/omniNotifiers".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_omni_notifiers(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/omniNotifiers".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_omni_notifier(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/OmniNotifierEmails/{0}/omniNotifier".format(self._id)
        self._session.call_api(api, attribs, 'get')

