# Leviton Cloud Services API model ResidentialPartner.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ResidentialPartner(BaseModel):
    def __init__(self, session):
        super(ResidentialPartner, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/findOne"
        session.call_api(api, attribs, 'get')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialPartners/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    def get_residential_partner(self, residential_partners, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/{1}".format(self._id, residential_partners)
        self._session.call_api(api, attribs, 'get')

    def delete_residential_partner(self, residential_partners, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/{1}".format(self._id, residential_partners)
        self._session.call_api(api, attribs, 'delete')

    def put_residential_partner(self, residential_partners, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/{1}".format(self._id, residential_partners)
        self._session.call_api(api, attribs, 'put')

    def get_residential_partners(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_residential_partners(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_residential_partners(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

