# Leviton Cloud Services API model Touchscreen.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class Touchscreen(BaseModel):
    def __init__(self, session):
        super(Touchscreen, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_area(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}/area".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_installation(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}/installation".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_device_definition(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}/deviceDefinition".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/findOne"
        session.call_api(api, attribs, 'get')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    def get_touchscreen(self, touchscreens, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/touchscreens/{1}".format(self._id, touchscreens)
        self._session.call_api(api, attribs, 'get')

    def delete_touchscreen(self, touchscreens, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/touchscreens/{1}".format(self._id, touchscreens)
        self._session.call_api(api, attribs, 'delete')

    def put_touchscreen(self, touchscreens, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/touchscreens/{1}".format(self._id, touchscreens)
        self._session.call_api(api, attribs, 'put')

    def get_touchscreens(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/touchscreens".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_touchscreens(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/touchscreens".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_touchscreens(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/touchscreens".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Installations/{0}/touchscreens/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

